<?php
/**
* Author: ghazal
* License: Don't distribute this plugin without my expressed permision.
* NOTE: Effort is made in developing this plugin, please do not break the license.
**/


if(!defined("IN_MYBB"))
{
	die("Sorry, direct file access is denied...");
}

// Plugin hook
$plugins->add_hook("showthread_start", "threads_decorator");
$plugins->add_hook("forumdisplay_thread", "threads_decorator");
$plugins->add_hook("showthread_start", "threads_decorator_button");
$plugins->add_hook("moderation_start", "threads_decorator_do");

// Plugin info
function threads_decorator_info()
{
	return array(
		"name"			=> "مدیریت موضوع های من",
		"description"	=> "مدیریت موضوع توسط کاربر برای انجمن های تعیین شده، فارسی سازی توسط MyBBIran.com",
		"website"		=> "mailto:ghazala.wali@gmail.com",
		"author"		=> "ghazal",
		"authorsite"	=> "mailto:ghazala.wali@gmail.com",
		"version"		=> "1.0",
		"guid" => "f9bd1acce4c23ae54a3fbfdaa99eead5",
		"compatibility" => "14*"
	);

}

// Activate plugin
function threads_decorator_activate()
{
	global $db;

// First we edit our templates.
include MYBB_ROOT."/inc/adminfunctions_templates.php";
find_replace_templatesets("forumdisplay_thread", "#".preg_quote('{$thread[\'subject\']}')."#i", '{\$stprf}{\$clprf}{\$clclr}{\$stclr}{\$str1}{\$thread[\'subject\']}{\$str2}{\$stimg}{\$clclr2}{\$stclr2}{\$climg}');
find_replace_templatesets("showthread", "#".preg_quote('{$newreply}')."#i", '{\$newreply}{\$close_button}');

	$threads_decorator_group = array(
		"gid"			=> "NULL",
		"name"			=> "threads_decorator",
		"title" 		=> "مدیریت موضوع های من",
		"description"	=> "تنظیمات پلاگین، فارسی سازی توسط MyBBIran.com",
		"disporder"		=> "1",
		"isdefault"		=> "no",
	);
	$db->insert_query("settinggroups", $threads_decorator_group);
	$gid = $db->insert_id();
	
	$threads_decorator_setting_1 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_enabled",
		"title"			=> "دکمه روشن/خاموش",
		"description"	=> "اگر می خواهید از این پلاگین استفاده کنید، آن را روشن کنید.",
		"optionscode"	=> "onoff",
		"value"			=> "off",
		"disporder"		=> "1",
		"gid"			=> intval($gid),
	);

	$db->insert_query("settings", $threads_decorator_setting_1);

	$threads_decorator_setting_2 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_sticky_color",
		"title"			=> "رنگ موضوع های مهم",
		"description"	=> "کد رنگ مورد نظر را وارد کنید. برای نمونه \"#FF0000\" برای <font color=\"#FF0000\">قرمز</font>",
		"optionscode"	=> "text",
		"value"			=> "#FF0000",
		"disporder"		=> "2",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_2);

	$threads_decorator_setting_3 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_sticky_prefix",
		"title"			=> "پیشوند موضوع های مهم",
		"description"	=> "آیا می خواهید از پیشوند برای موضوع های مهم استفاده کنید؟",
		"optionscode"	=> "text",
		"value"			=> "<strong>مهم:</strong>&nbsp;&nbsp;",
		"disporder"		=> "3",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_3);

	$threads_decorator_setting_4 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_sticky_image",
		"title"			=> "تصویر موضوع های مهم",
		"description"	=> "آیا می خواهید برای موضوع های مهم از تصویر استفاده کنید. (تصویر در کنار عنوان موضوع نمایش داده می شود)",
		"optionscode"	=> "yesno",
		"value"			=> "no",
		"disporder"		=> "4",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_4);

	$threads_decorator_setting_5 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_color",
		"title"			=> "رنگ موضوع های [حل شده] ",
		"description"	=> "کد رنگ مورد نظر را وارد کنید. برای نمونه \"#FF0000\" برای <font color=\"#FF0000\">قرمز</font>",
		"optionscode"	=> "text",
		"value"			=> "#FF0000",
		"disporder"		=> "5",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_5);

	$threads_decorator_setting_6 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_prefix",
		"title"			=> "پیشوند موضوع های [حل شده] ",
		"description"	=> "آیا می خواهید برای موضوع های [حل شده] شده از پیشوند استفاده کنید؟",
		"optionscode"	=> "text",
		"value"			=> "<strong>[حل شده]:</strong>&nbsp;&nbsp;",
		"disporder"		=> "6",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_6);

	$threads_decorator_setting_7 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_image",
		"title"			=> "تصویر موضوع های حل شده (بسته شده)",
		"description"	=> "آیا می خواهید برای موضوع های بسته شده از تصویر استفاده کنید. (تصویر در کنار عنوان موضوع نمایش داده می شود)",
		"optionscode"	=> "yesno",
		"value"			=> "no",
		"disporder"		=> "7",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_7);

	$threads_decorator_setting_8 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_strike",
		"title"			=> "پر رنگ شدن موضوع های بسته شده",
		"description"	=> "آیا می خواهید موضوع های بسته شده پر رنگ تر شوند؟",
		"optionscode"	=> "yesno",
		"value"			=> "no",
		"disporder"		=> "8",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_8);

	$threads_decorator_setting_9 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_gid",
		"title"			=> "چه کسانی می توانند موضوع های خود را قفل کنند؟",
		"description"	=> "لطفا ID های گروه های کاربر مورد نظر که می توانند موضوع های خودشان را قفل کنند وارد کنید. (آن ها را با کاما از هم جدا کنید)<br/>توجه: <i>بعد از قفل شدن، موضوع به عنوان [حل شده] معرفی می شود و هیچ کس به جز مدیر کل و مدیران نمی توانند آن را دوباره باز کنند.</i>",
		"optionscode"	=> "text",
		"value"			=> "2,3,4",
		"disporder"		=> "9",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_9);

	$threads_decorator_setting_10 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_movefid",
		"title"			=> "انتقال به انجمن",
		"description"	=> "اگر شما می خواهید موضوع های [حل شده] به انجمن دیگری منتقل شوند، لطفا ID آن انجمن را وارد کنید.<br/>توجه: <i>این قسمت انجمنی است که موضوع های [حل شده] به آن منتقل می شوند.</i>",
		"optionscode"	=> "text",
		"value"			=> "3",
		"disporder"		=> "10",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_10);

	$threads_decorator_setting_11 = array(
		"sid"			=> "NULL",
		"name"			=> "threads_decorator_closed_fid",
		"title"			=> "ID انجمن",
		"description"	=> "ID انجمنی که این عملکرد باید انجام شود وارد کنید.<br/>توجه: <i>این قسمت آی دی انجمنی می باشد که عملکرد [حل شده] در موضوع های آن اجرا می شود.</i>",
		"optionscode"	=> "text",
		"value"			=> "2",
		"disporder"		=> "11",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query("settings", $threads_decorator_setting_11);
	
	// Rebuilding settings
    rebuildsettings();
}

// Deactivate plugin
function threads_decorator_deactivate()
{
	global $db;

// Revert the changed template.
include MYBB_ROOT."/inc/adminfunctions_templates.php";
find_replace_templatesets("forumdisplay_thread", "#".preg_quote('{$stprf}{$clprf}{$clclr}{$stclr}{$str1}{$thread[\'subject\']}{$str2}{$stimg}{$clclr2}{$stclr2}{$climg}')."#i", '{$thread[\'subject\']}', 0);
find_replace_templatesets("showthread", "#".preg_quote('{$close_button}')."#i", '', 0);

// Delete settings.
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='threads_decorator'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_enabled'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_sticky_color'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_sticky_prefix'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_sticky_image'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_color'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_prefix'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_image'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_strike'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_gid'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_movefid'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='threads_decorator_closed_fid'");
	
	// Rebuilding settings
    rebuildsettings();
}

// Run plugin
function threads_decorator()
{
	global $db, $mybb, $lang, $stprf, $stclr, $stimg, $clprf, $clclr, $climg, $str1, $str2, $thread, $templates, $themes;

	$enable = $mybb->settings['threads_decorator_enabled'];

	if ($enable == '0')
	{
		return;
	}
if ($thread['sticky'])
{
	$stickyclr = $mybb->settings['threads_decorator_sticky_color'];
		$stclr = "<font color=".$stickyclr.">";
		$stclr2 = "</font>";

	$stickyprf = $mybb->settings['threads_decorator_sticky_prefix'];
		$stprf = "$stickyprf";
}
	if ($mybb->settings['threads_decorator_sticky_image'] == '1' && $thread['sticky'])
	{
		$stimg = "<img src=\"images/sticky.png\" align=\"left\">";
	}
	else
	{
		$stimg = "";
	}
	if (!$thread['sticky'])
	{
		$stclr = "";

		$stprf = "";
}

if ($thread['closed'])
{
	$closedclr = $mybb->settings['threads_decorator_closed_color'];
		$clclr = "<font color=".$closedclr.">";
		$clclr2 = "</font>";

	$closedprf = $mybb->settings['threads_decorator_closed_prefix'];
		$clprf = "$closedprf";
}
	if ($mybb->settings['threads_decorator_closed_image'] == '1' && $thread['closed'])
	{
		$climg = "<img src=\"images/solved.png\" align=\"left\">";
	}
	else
	{
		$climg = "";
	}
	if ($mybb->settings['threads_decorator_closed_strike'] == 1 && $thread['closed'])
	{
		$str1 = '<s>';
		$str2 = '</s>';
	}
	else
	{
		$str1 = '';
		$str2 = '';
	}
	if (!$thread['closed'])
	{
		$clclr = "";

		$clprf = "";
	}
}

// Now build up the button for Thread Authors
function threads_decorator_button()
{
	global $db, $mybb, $thread, $fid, $usergroup, $groupscache, $templates, $close_button;
	$enable = $mybb->settings['threads_decorator_enabled'];
	$gid = $mybb->user['usergroup'];
	$xgid = explode(",",$mybb->settings['threads_decorator_closed_gid']);
	$xfid = explode(",",$mybb->settings['threads_decorator_closed_fid']);

	if ($enable != '0')
	{
		if (in_array($gid,$xgid) && in_array($thread['fid'],$xfid) && $mybb->user['uid'] == $thread['uid'] && !$thread['closed'])
		{
			$close_button = '
<form action="moderation.php" method="post">
<input type="hidden" name="tid" value="'.$thread['tid'].'" />
<input type="hidden" name="action" value="solve" />
<input type="hidden" name="my_post_key" value="'.$mybb->post_code.'" />
<input type="image" src="images/close.png" alt="بستن این موضوع" title="بستن این موضوع" name="submit" />
</form>';
		}
	}
}

// Now we will close our [SOLVE] requested thread
function threads_decorator_do($tid)
{
	global $db, $mybb, $lang, $modlogdata, $moderation, $thread;
	$gid = $mybb->user['usergroup'];
	$xgid = explode(",",$mybb->settings['threads_decorator_closed_gid']);
	$xfid = explode(",",$mybb->settings['threads_decorator_closed_fid']);
	
	if($mybb->request_method != 'post')
	{
		error_no_permission();
	}
	if($mybb->input['action'] != 'solve')
	{
		return;
	}
	$tid = intval($mybb->input['tid']);
	$thread = get_thread($tid);
	if($thread['closed']==1)
	{
		error("پوزش، این موضوع قبلا [حل شده است].");
	}
	if (!in_array($gid,$xgid))
	{
		error_no_permission();
	}
		// Verify incoming POST request
		verify_post_check($mybb->input['my_post_key']);
		$openclose = $lang->closed;
		$redirect = $lang->redirect_closethread;
		$moderation->close_threads($tid);
		$lang->mod_process = $lang->sprintf($lang->mod_process, $openclose);
		$modlogdata['tid'] = $tid;
		log_moderator_action($modlogdata, $lang->mod_process);
		moderation_redirect(get_thread_link($thread['tid']), $redirect);
		break;

	if ($mybb->settings['threads_decorator_closed_movefid'] != "")
	{
		$db->update_query('threads', array('fid' => $mybb->settings['threads_decorator_closed_movefid']), 'tid='.$thread['tid']);
		$db->update_query('posts', array('fid' => $mybb->settings['threads_decorator_closed_movefid']), 'tid='.$thread['tid']);
		redirect('showthread.php?tid='.$thread['tid'], "موضوع  [حل شده است] ...
");
	}
}
// Thank You for using ghazal's plugin.
?>